=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

The version of the OpenAPI document: 2.14.7
Contact: support@combase.net
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0

=end

require 'cgi'

module KoronaCloudClient
  class StockReceiptsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # adds stock-receipt items
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [Array<StockReceiptItem>] data to add
    # @param [Hash] opts the optional parameters
    # @return [Array<AddOrUpdateResult>]
    def add_stock_receipt_items(korona_account_id, stock_receipt_id, body, opts = {})
      data, _status_code, _headers = add_stock_receipt_items_with_http_info(korona_account_id, stock_receipt_id, body, opts)
      data
    end

    # adds stock-receipt items
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [Array<StockReceiptItem>] data to add
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<AddOrUpdateResult>, Integer, Hash)>] Array<AddOrUpdateResult> data, response status code and response headers
    def add_stock_receipt_items_with_http_info(korona_account_id, stock_receipt_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.add_stock_receipt_items ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.add_stock_receipt_items"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.add_stock_receipt_items"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling StockReceiptsApi.add_stock_receipt_items"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/items'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'Array<AddOrUpdateResult>' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#add_stock_receipt_items\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # adds stock-receipts
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param body [Array<StockReceipt>] data to add
    # @param [Hash] opts the optional parameters
    # @return [Array<AddOrUpdateResult>]
    def add_stock_receipts(korona_account_id, body, opts = {})
      data, _status_code, _headers = add_stock_receipts_with_http_info(korona_account_id, body, opts)
      data
    end

    # adds stock-receipts
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param body [Array<StockReceipt>] data to add
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<AddOrUpdateResult>, Integer, Hash)>] Array<AddOrUpdateResult> data, response status code and response headers
    def add_stock_receipts_with_http_info(korona_account_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.add_stock_receipts ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.add_stock_receipts"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling StockReceiptsApi.add_stock_receipts"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'Array<AddOrUpdateResult>' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#add_stock_receipts\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # book the single stock-receipt
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def book_stock_receipt(korona_account_id, stock_receipt_id, opts = {})
      book_stock_receipt_with_http_info(korona_account_id, stock_receipt_id, opts)
      nil
    end

    # book the single stock-receipt
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def book_stock_receipt_with_http_info(korona_account_id, stock_receipt_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.book_stock_receipt ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.book_stock_receipt"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.book_stock_receipt"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/book'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#book_stock_receipt\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # deletes the single stock-receipt item
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param product_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_stock_receipt_item(korona_account_id, stock_receipt_id, product_id, opts = {})
      delete_stock_receipt_item_with_http_info(korona_account_id, stock_receipt_id, product_id, opts)
      nil
    end

    # deletes the single stock-receipt item
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param product_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_stock_receipt_item_with_http_info(korona_account_id, stock_receipt_id, product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.delete_stock_receipt_item ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.delete_stock_receipt_item"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.delete_stock_receipt_item"
      end
      # verify the required parameter 'product_id' is set
      if @api_client.config.client_side_validation && product_id.nil?
        fail ArgumentError, "Missing the required parameter 'product_id' when calling StockReceiptsApi.delete_stock_receipt_item"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/items/{productId}'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s)).sub('{' + 'productId' + '}', CGI.escape(product_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#delete_stock_receipt_item\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # returns the single stock-receipt
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [StockReceipt]
    def get_stock_receipt(korona_account_id, stock_receipt_id, opts = {})
      data, _status_code, _headers = get_stock_receipt_with_http_info(korona_account_id, stock_receipt_id, opts)
      data
    end

    # returns the single stock-receipt
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [Array<(StockReceipt, Integer, Hash)>] StockReceipt data, response status code and response headers
    def get_stock_receipt_with_http_info(korona_account_id, stock_receipt_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.get_stock_receipt ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.get_stock_receipt"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.get_stock_receipt"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'StockReceipt' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#get_stock_receipt\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # returns the single stock-receipt item
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param product_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [StockReceiptItem]
    def get_stock_receipt_item(korona_account_id, stock_receipt_id, product_id, opts = {})
      data, _status_code, _headers = get_stock_receipt_item_with_http_info(korona_account_id, stock_receipt_id, product_id, opts)
      data
    end

    # returns the single stock-receipt item
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param product_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [Array<(StockReceiptItem, Integer, Hash)>] StockReceiptItem data, response status code and response headers
    def get_stock_receipt_item_with_http_info(korona_account_id, stock_receipt_id, product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.get_stock_receipt_item ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.get_stock_receipt_item"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.get_stock_receipt_item"
      end
      # verify the required parameter 'product_id' is set
      if @api_client.config.client_side_validation && product_id.nil?
        fail ArgumentError, "Missing the required parameter 'product_id' when calling StockReceiptsApi.get_stock_receipt_item"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/items/{productId}'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s)).sub('{' + 'productId' + '}', CGI.escape(product_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'StockReceiptItem' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#get_stock_receipt_item\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # lists all stock-receipt items
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page number of the page to fetch
    # @option opts [Integer] :size amount of objects to return per page
    # @option opts [String] :sort attribute to sort by (multiple separated by comma; max. 5)
    # @option opts [Integer] :revision last revision number, objects with a greater revision than this will be returned
    # @return [ResultListStockReceiptItem]
    def get_stock_receipt_items(korona_account_id, stock_receipt_id, opts = {})
      data, _status_code, _headers = get_stock_receipt_items_with_http_info(korona_account_id, stock_receipt_id, opts)
      data
    end

    # lists all stock-receipt items
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page number of the page to fetch
    # @option opts [Integer] :size amount of objects to return per page
    # @option opts [String] :sort attribute to sort by (multiple separated by comma; max. 5)
    # @option opts [Integer] :revision last revision number, objects with a greater revision than this will be returned
    # @return [Array<(ResultListStockReceiptItem, Integer, Hash)>] ResultListStockReceiptItem data, response status code and response headers
    def get_stock_receipt_items_with_http_info(korona_account_id, stock_receipt_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.get_stock_receipt_items ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.get_stock_receipt_items"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.get_stock_receipt_items"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/items'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?
      query_params[:'revision'] = opts[:'revision'] if !opts[:'revision'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ResultListStockReceiptItem' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#get_stock_receipt_items\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # lists all stock-receipts
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page number of the page to fetch
    # @option opts [Integer] :size amount of objects to return per page
    # @option opts [String] :sort attribute to sort by (multiple separated by comma; max. 5)
    # @option opts [Integer] :revision last revision number, objects with a greater revision than this will be returned
    # @option opts [Boolean] :include_deleted indicates deleted objects should be loaded or not (default: false)
    # @option opts [DateTime] :min_create_time min (inclusive) create time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [DateTime] :max_create_time max (inclusive) create time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [DateTime] :min_booking_time min (inclusive) booking time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [DateTime] :max_booking_time max (inclusive) booking time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [String] :organizational_unit organizational unit
    # @option opts [String] :source_organizational_unit source organizational unit
    # @option opts [String] :booking_status booking status (possible values: BOOKED, IN_PROGRESS)
    # @option opts [String] :number number of the related object
    # @return [ResultListStockReceipt]
    def get_stock_receipts(korona_account_id, opts = {})
      data, _status_code, _headers = get_stock_receipts_with_http_info(korona_account_id, opts)
      data
    end

    # lists all stock-receipts
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page number of the page to fetch
    # @option opts [Integer] :size amount of objects to return per page
    # @option opts [String] :sort attribute to sort by (multiple separated by comma; max. 5)
    # @option opts [Integer] :revision last revision number, objects with a greater revision than this will be returned
    # @option opts [Boolean] :include_deleted indicates deleted objects should be loaded or not (default: false)
    # @option opts [DateTime] :min_create_time min (inclusive) create time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [DateTime] :max_create_time max (inclusive) create time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [DateTime] :min_booking_time min (inclusive) booking time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [DateTime] :max_booking_time max (inclusive) booking time of the receipt (ISO 8601; Format: YYYY-MM-DDTHH:MM:SS; timezone optional)
    # @option opts [String] :organizational_unit organizational unit
    # @option opts [String] :source_organizational_unit source organizational unit
    # @option opts [String] :booking_status booking status (possible values: BOOKED, IN_PROGRESS)
    # @option opts [String] :number number of the related object
    # @return [Array<(ResultListStockReceipt, Integer, Hash)>] ResultListStockReceipt data, response status code and response headers
    def get_stock_receipts_with_http_info(korona_account_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.get_stock_receipts ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.get_stock_receipts"
      end
      allowable_values = ["BOOKED", "IN_PROGRESS"]
      if @api_client.config.client_side_validation && opts[:'booking_status'] && !allowable_values.include?(opts[:'booking_status'])
        fail ArgumentError, "invalid value for \"booking_status\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?
      query_params[:'revision'] = opts[:'revision'] if !opts[:'revision'].nil?
      query_params[:'includeDeleted'] = opts[:'include_deleted'] if !opts[:'include_deleted'].nil?
      query_params[:'minCreateTime'] = opts[:'min_create_time'] if !opts[:'min_create_time'].nil?
      query_params[:'maxCreateTime'] = opts[:'max_create_time'] if !opts[:'max_create_time'].nil?
      query_params[:'minBookingTime'] = opts[:'min_booking_time'] if !opts[:'min_booking_time'].nil?
      query_params[:'maxBookingTime'] = opts[:'max_booking_time'] if !opts[:'max_booking_time'].nil?
      query_params[:'organizationalUnit'] = opts[:'organizational_unit'] if !opts[:'organizational_unit'].nil?
      query_params[:'sourceOrganizationalUnit'] = opts[:'source_organizational_unit'] if !opts[:'source_organizational_unit'].nil?
      query_params[:'bookingStatus'] = opts[:'booking_status'] if !opts[:'booking_status'].nil?
      query_params[:'number'] = opts[:'number'] if !opts[:'number'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ResultListStockReceipt' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#get_stock_receipts\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # updates the single stock-receipt
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [StockReceipt] data to update
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_stock_receipt(korona_account_id, stock_receipt_id, body, opts = {})
      update_stock_receipt_with_http_info(korona_account_id, stock_receipt_id, body, opts)
      nil
    end

    # updates the single stock-receipt
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [StockReceipt] data to update
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def update_stock_receipt_with_http_info(korona_account_id, stock_receipt_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.update_stock_receipt ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.update_stock_receipt"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.update_stock_receipt"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling StockReceiptsApi.update_stock_receipt"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#update_stock_receipt\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # updates the single stock-receipt item
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param product_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [StockReceiptItem] data to update
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_stock_receipt_item(korona_account_id, stock_receipt_id, product_id, body, opts = {})
      update_stock_receipt_item_with_http_info(korona_account_id, stock_receipt_id, product_id, body, opts)
      nil
    end

    # updates the single stock-receipt item
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param product_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [StockReceiptItem] data to update
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def update_stock_receipt_item_with_http_info(korona_account_id, stock_receipt_id, product_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.update_stock_receipt_item ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.update_stock_receipt_item"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.update_stock_receipt_item"
      end
      # verify the required parameter 'product_id' is set
      if @api_client.config.client_side_validation && product_id.nil?
        fail ArgumentError, "Missing the required parameter 'product_id' when calling StockReceiptsApi.update_stock_receipt_item"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling StockReceiptsApi.update_stock_receipt_item"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/items/{productId}'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s)).sub('{' + 'productId' + '}', CGI.escape(product_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#update_stock_receipt_item\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # updates stock-receipt items
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [Array<StockReceiptItem>] data to update
    # @param [Hash] opts the optional parameters
    # @return [Array<AddOrUpdateResult>]
    def update_stock_receipt_items(korona_account_id, stock_receipt_id, body, opts = {})
      data, _status_code, _headers = update_stock_receipt_items_with_http_info(korona_account_id, stock_receipt_id, body, opts)
      data
    end

    # updates stock-receipt items
    # @param korona_account_id [String] account id of the KORONA.cloud account
    # @param stock_receipt_id [String] id of the related object (important: id should match the uuid-format)
    # @param body [Array<StockReceiptItem>] data to update
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<AddOrUpdateResult>, Integer, Hash)>] Array<AddOrUpdateResult> data, response status code and response headers
    def update_stock_receipt_items_with_http_info(korona_account_id, stock_receipt_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StockReceiptsApi.update_stock_receipt_items ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling StockReceiptsApi.update_stock_receipt_items"
      end
      # verify the required parameter 'stock_receipt_id' is set
      if @api_client.config.client_side_validation && stock_receipt_id.nil?
        fail ArgumentError, "Missing the required parameter 'stock_receipt_id' when calling StockReceiptsApi.update_stock_receipt_items"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling StockReceiptsApi.update_stock_receipt_items"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/stockReceipts/{stockReceiptId}/items'.sub('{' + 'koronaAccountId' + '}', CGI.escape(korona_account_id.to_s)).sub('{' + 'stockReceiptId' + '}', CGI.escape(stock_receipt_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'Array<AddOrUpdateResult>' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StockReceiptsApi#update_stock_receipt_items\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
