=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

The version of the OpenAPI document: 2.14.7
Contact: support@combase.net
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0

=end

require 'date'

module KoronaCloudClient
  class Pos
    # indicates whether the object is active for use or not
    attr_accessor :active

    # global object uuid (xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)
    attr_accessor :id

    # number of the object, like it is set in backoffice; will be removed when active=false
    attr_accessor :number

    # the revision number of the object. revision numbers are unique per object-type. there is is no object of the same type with identical revision numbers.
    attr_accessor :revision

    attr_accessor :contra_account

    attr_accessor :coupled

    attr_accessor :coupling_id

    attr_accessor :default_customer_group

    attr_accessor :default_payment_method

    attr_accessor :device_information

    attr_accessor :external

    attr_accessor :fiscal_unit

    # last receipt number - only shown if external=true and coupled=false; usable for client-side receipt counter.
    attr_accessor :last_receipt_number

    # last zcount property - only shown if external=true and coupled=false; usable for client-side zcount.
    attr_accessor :last_z_count

    attr_accessor :name

    attr_accessor :organizational_unit

    attr_accessor :print_footer_lines

    attr_accessor :print_header_lines

    attr_accessor :receipt_info_texts

    attr_accessor :receipt_number_prefix

    attr_accessor :revenue_account

    attr_accessor :use_alternative_sector

    attr_accessor :warehouse

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'active' => :'active',
        :'id' => :'id',
        :'number' => :'number',
        :'revision' => :'revision',
        :'contra_account' => :'contraAccount',
        :'coupled' => :'coupled',
        :'coupling_id' => :'couplingId',
        :'default_customer_group' => :'defaultCustomerGroup',
        :'default_payment_method' => :'defaultPaymentMethod',
        :'device_information' => :'deviceInformation',
        :'external' => :'external',
        :'fiscal_unit' => :'fiscalUnit',
        :'last_receipt_number' => :'lastReceiptNumber',
        :'last_z_count' => :'lastZCount',
        :'name' => :'name',
        :'organizational_unit' => :'organizationalUnit',
        :'print_footer_lines' => :'printFooterLines',
        :'print_header_lines' => :'printHeaderLines',
        :'receipt_info_texts' => :'receiptInfoTexts',
        :'receipt_number_prefix' => :'receiptNumberPrefix',
        :'revenue_account' => :'revenueAccount',
        :'use_alternative_sector' => :'useAlternativeSector',
        :'warehouse' => :'warehouse'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'active' => :'Boolean',
        :'id' => :'String',
        :'number' => :'String',
        :'revision' => :'Integer',
        :'contra_account' => :'ModelReference',
        :'coupled' => :'Boolean',
        :'coupling_id' => :'String',
        :'default_customer_group' => :'ModelReference',
        :'default_payment_method' => :'ModelReference',
        :'device_information' => :'DeviceInformation',
        :'external' => :'Boolean',
        :'fiscal_unit' => :'ModelReference',
        :'last_receipt_number' => :'String',
        :'last_z_count' => :'Integer',
        :'name' => :'String',
        :'organizational_unit' => :'ModelReference',
        :'print_footer_lines' => :'Hash<String, String>',
        :'print_header_lines' => :'Hash<String, String>',
        :'receipt_info_texts' => :'Array<ModelReference>',
        :'receipt_number_prefix' => :'String',
        :'revenue_account' => :'ModelReference',
        :'use_alternative_sector' => :'Boolean',
        :'warehouse' => :'ModelReference'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `KoronaCloudClient::Pos` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `KoronaCloudClient::Pos`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'number')
        self.number = attributes[:'number']
      end

      if attributes.key?(:'revision')
        self.revision = attributes[:'revision']
      end

      if attributes.key?(:'contra_account')
        self.contra_account = attributes[:'contra_account']
      end

      if attributes.key?(:'coupled')
        self.coupled = attributes[:'coupled']
      end

      if attributes.key?(:'coupling_id')
        self.coupling_id = attributes[:'coupling_id']
      end

      if attributes.key?(:'default_customer_group')
        self.default_customer_group = attributes[:'default_customer_group']
      end

      if attributes.key?(:'default_payment_method')
        self.default_payment_method = attributes[:'default_payment_method']
      end

      if attributes.key?(:'device_information')
        self.device_information = attributes[:'device_information']
      end

      if attributes.key?(:'external')
        self.external = attributes[:'external']
      end

      if attributes.key?(:'fiscal_unit')
        self.fiscal_unit = attributes[:'fiscal_unit']
      end

      if attributes.key?(:'last_receipt_number')
        self.last_receipt_number = attributes[:'last_receipt_number']
      end

      if attributes.key?(:'last_z_count')
        self.last_z_count = attributes[:'last_z_count']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'organizational_unit')
        self.organizational_unit = attributes[:'organizational_unit']
      end

      if attributes.key?(:'print_footer_lines')
        if (value = attributes[:'print_footer_lines']).is_a?(Hash)
          self.print_footer_lines = value
        end
      end

      if attributes.key?(:'print_header_lines')
        if (value = attributes[:'print_header_lines']).is_a?(Hash)
          self.print_header_lines = value
        end
      end

      if attributes.key?(:'receipt_info_texts')
        if (value = attributes[:'receipt_info_texts']).is_a?(Array)
          self.receipt_info_texts = value
        end
      end

      if attributes.key?(:'receipt_number_prefix')
        self.receipt_number_prefix = attributes[:'receipt_number_prefix']
      end

      if attributes.key?(:'revenue_account')
        self.revenue_account = attributes[:'revenue_account']
      end

      if attributes.key?(:'use_alternative_sector')
        self.use_alternative_sector = attributes[:'use_alternative_sector']
      end

      if attributes.key?(:'warehouse')
        self.warehouse = attributes[:'warehouse']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          active == o.active &&
          id == o.id &&
          number == o.number &&
          revision == o.revision &&
          contra_account == o.contra_account &&
          coupled == o.coupled &&
          coupling_id == o.coupling_id &&
          default_customer_group == o.default_customer_group &&
          default_payment_method == o.default_payment_method &&
          device_information == o.device_information &&
          external == o.external &&
          fiscal_unit == o.fiscal_unit &&
          last_receipt_number == o.last_receipt_number &&
          last_z_count == o.last_z_count &&
          name == o.name &&
          organizational_unit == o.organizational_unit &&
          print_footer_lines == o.print_footer_lines &&
          print_header_lines == o.print_header_lines &&
          receipt_info_texts == o.receipt_info_texts &&
          receipt_number_prefix == o.receipt_number_prefix &&
          revenue_account == o.revenue_account &&
          use_alternative_sector == o.use_alternative_sector &&
          warehouse == o.warehouse
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [active, id, number, revision, contra_account, coupled, coupling_id, default_customer_group, default_payment_method, device_information, external, fiscal_unit, last_receipt_number, last_z_count, name, organizational_unit, print_footer_lines, print_header_lines, receipt_info_texts, receipt_number_prefix, revenue_account, use_alternative_sector, warehouse].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        KoronaCloudClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
