=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

The version of the OpenAPI document: 2.14.7
Contact: support@combase.net
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0

=end

require 'date'

module KoronaCloudClient
  class Receipt
    # indicates whether the object is active for use or not
    attr_accessor :active

    # global object uuid (xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)
    attr_accessor :id

    # number of the object, like it is set in backoffice; will be removed when active=false
    attr_accessor :number

    # the revision number of the object. revision numbers are unique per object-type. there is is no object of the same type with identical revision numbers.
    attr_accessor :revision

    attr_accessor :account_transactions

    attr_accessor :additional_info

    attr_accessor :booking_time

    attr_accessor :cancelled

    attr_accessor :cashier

    attr_accessor :creation_time

    attr_accessor :currency

    attr_accessor :customer

    attr_accessor :customer_group

    attr_accessor :deposit_amount

    attr_accessor :fiscal_transactions

    attr_accessor :geo_location

    attr_accessor :info_texts

    attr_accessor :items

    attr_accessor :max_revisions

    attr_accessor :order_number

    attr_accessor :organizational_unit

    attr_accessor :payments

    attr_accessor :point_of_sale

    attr_accessor :price_group

    attr_accessor :signature

    attr_accessor :voided

    attr_accessor :voided_items

    attr_accessor :void_fiscal_transactions

    attr_accessor :warehouse

    attr_accessor :zcounter

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'active' => :'active',
        :'id' => :'id',
        :'number' => :'number',
        :'revision' => :'revision',
        :'account_transactions' => :'accountTransactions',
        :'additional_info' => :'additionalInfo',
        :'booking_time' => :'bookingTime',
        :'cancelled' => :'cancelled',
        :'cashier' => :'cashier',
        :'creation_time' => :'creationTime',
        :'currency' => :'currency',
        :'customer' => :'customer',
        :'customer_group' => :'customerGroup',
        :'deposit_amount' => :'depositAmount',
        :'fiscal_transactions' => :'fiscalTransactions',
        :'geo_location' => :'geoLocation',
        :'info_texts' => :'infoTexts',
        :'items' => :'items',
        :'max_revisions' => :'maxRevisions',
        :'order_number' => :'orderNumber',
        :'organizational_unit' => :'organizationalUnit',
        :'payments' => :'payments',
        :'point_of_sale' => :'pointOfSale',
        :'price_group' => :'priceGroup',
        :'signature' => :'signature',
        :'voided' => :'voided',
        :'voided_items' => :'voidedItems',
        :'void_fiscal_transactions' => :'voidFiscalTransactions',
        :'warehouse' => :'warehouse',
        :'zcounter' => :'zcounter'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'active' => :'Boolean',
        :'id' => :'String',
        :'number' => :'String',
        :'revision' => :'Integer',
        :'account_transactions' => :'Array<AccountTransaction>',
        :'additional_info' => :'Array<AdditionalInfo>',
        :'booking_time' => :'DateTime',
        :'cancelled' => :'Boolean',
        :'cashier' => :'ModelReference',
        :'creation_time' => :'DateTime',
        :'currency' => :'ModelReference',
        :'customer' => :'ModelReference',
        :'customer_group' => :'ModelReference',
        :'deposit_amount' => :'Float',
        :'fiscal_transactions' => :'Array<FiscalTransaction>',
        :'geo_location' => :'GeoLocation',
        :'info_texts' => :'Array<String>',
        :'items' => :'Array<ReceiptItem>',
        :'max_revisions' => :'ReceiptMaxRevisions',
        :'order_number' => :'String',
        :'organizational_unit' => :'ModelReference',
        :'payments' => :'Array<Payment>',
        :'point_of_sale' => :'ModelReference',
        :'price_group' => :'ModelReference',
        :'signature' => :'Signature',
        :'voided' => :'Boolean',
        :'voided_items' => :'Array<VoidedReceiptItem>',
        :'void_fiscal_transactions' => :'Array<FiscalTransaction>',
        :'warehouse' => :'ModelReference',
        :'zcounter' => :'Integer'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `KoronaCloudClient::Receipt` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `KoronaCloudClient::Receipt`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'number')
        self.number = attributes[:'number']
      end

      if attributes.key?(:'revision')
        self.revision = attributes[:'revision']
      end

      if attributes.key?(:'account_transactions')
        if (value = attributes[:'account_transactions']).is_a?(Array)
          self.account_transactions = value
        end
      end

      if attributes.key?(:'additional_info')
        if (value = attributes[:'additional_info']).is_a?(Array)
          self.additional_info = value
        end
      end

      if attributes.key?(:'booking_time')
        self.booking_time = attributes[:'booking_time']
      end

      if attributes.key?(:'cancelled')
        self.cancelled = attributes[:'cancelled']
      end

      if attributes.key?(:'cashier')
        self.cashier = attributes[:'cashier']
      end

      if attributes.key?(:'creation_time')
        self.creation_time = attributes[:'creation_time']
      end

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.key?(:'customer')
        self.customer = attributes[:'customer']
      end

      if attributes.key?(:'customer_group')
        self.customer_group = attributes[:'customer_group']
      end

      if attributes.key?(:'deposit_amount')
        self.deposit_amount = attributes[:'deposit_amount']
      end

      if attributes.key?(:'fiscal_transactions')
        if (value = attributes[:'fiscal_transactions']).is_a?(Array)
          self.fiscal_transactions = value
        end
      end

      if attributes.key?(:'geo_location')
        self.geo_location = attributes[:'geo_location']
      end

      if attributes.key?(:'info_texts')
        if (value = attributes[:'info_texts']).is_a?(Array)
          self.info_texts = value
        end
      end

      if attributes.key?(:'items')
        if (value = attributes[:'items']).is_a?(Array)
          self.items = value
        end
      end

      if attributes.key?(:'max_revisions')
        self.max_revisions = attributes[:'max_revisions']
      end

      if attributes.key?(:'order_number')
        self.order_number = attributes[:'order_number']
      end

      if attributes.key?(:'organizational_unit')
        self.organizational_unit = attributes[:'organizational_unit']
      end

      if attributes.key?(:'payments')
        if (value = attributes[:'payments']).is_a?(Array)
          self.payments = value
        end
      end

      if attributes.key?(:'point_of_sale')
        self.point_of_sale = attributes[:'point_of_sale']
      end

      if attributes.key?(:'price_group')
        self.price_group = attributes[:'price_group']
      end

      if attributes.key?(:'signature')
        self.signature = attributes[:'signature']
      end

      if attributes.key?(:'voided')
        self.voided = attributes[:'voided']
      end

      if attributes.key?(:'voided_items')
        if (value = attributes[:'voided_items']).is_a?(Array)
          self.voided_items = value
        end
      end

      if attributes.key?(:'void_fiscal_transactions')
        if (value = attributes[:'void_fiscal_transactions']).is_a?(Array)
          self.void_fiscal_transactions = value
        end
      end

      if attributes.key?(:'warehouse')
        self.warehouse = attributes[:'warehouse']
      end

      if attributes.key?(:'zcounter')
        self.zcounter = attributes[:'zcounter']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          active == o.active &&
          id == o.id &&
          number == o.number &&
          revision == o.revision &&
          account_transactions == o.account_transactions &&
          additional_info == o.additional_info &&
          booking_time == o.booking_time &&
          cancelled == o.cancelled &&
          cashier == o.cashier &&
          creation_time == o.creation_time &&
          currency == o.currency &&
          customer == o.customer &&
          customer_group == o.customer_group &&
          deposit_amount == o.deposit_amount &&
          fiscal_transactions == o.fiscal_transactions &&
          geo_location == o.geo_location &&
          info_texts == o.info_texts &&
          items == o.items &&
          max_revisions == o.max_revisions &&
          order_number == o.order_number &&
          organizational_unit == o.organizational_unit &&
          payments == o.payments &&
          point_of_sale == o.point_of_sale &&
          price_group == o.price_group &&
          signature == o.signature &&
          voided == o.voided &&
          voided_items == o.voided_items &&
          void_fiscal_transactions == o.void_fiscal_transactions &&
          warehouse == o.warehouse &&
          zcounter == o.zcounter
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [active, id, number, revision, account_transactions, additional_info, booking_time, cancelled, cashier, creation_time, currency, customer, customer_group, deposit_amount, fiscal_transactions, geo_location, info_texts, items, max_revisions, order_number, organizational_unit, payments, point_of_sale, price_group, signature, voided, voided_items, void_fiscal_transactions, warehouse, zcounter].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        KoronaCloudClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
