=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

The version of the OpenAPI document: 2.14.7
Contact: support@combase.net
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0

=end

require 'date'

module KoronaCloudClient
  class StockOrder
    # indicates whether the object is active for use or not
    attr_accessor :active

    # global object uuid (xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)
    attr_accessor :id

    # number of the object, like it is set in backoffice; will be removed when active=false
    attr_accessor :number

    # the revision number of the object. revision numbers are unique per object-type. there is is no object of the same type with identical revision numbers.
    attr_accessor :revision

    attr_accessor :booking_time

    attr_accessor :booking_user

    attr_accessor :booking_api_user

    attr_accessor :cashier

    attr_accessor :create_time

    attr_accessor :create_user

    attr_accessor :customer

    attr_accessor :description

    attr_accessor :items_count

    attr_accessor :organizational_unit

    attr_accessor :party_information

    attr_accessor :point_of_sale

    attr_accessor :source_organizational_unit

    attr_accessor :supplier

    attr_accessor :comment

    attr_accessor :deposit

    attr_accessor :pickup_date

    attr_accessor :store_order

    attr_accessor :special_offer_code

    attr_accessor :shipping_condition

    attr_accessor :shipping_supplier_information

    attr_accessor :expected_from_date

    attr_accessor :expected_to_date

    attr_accessor :items

    attr_accessor :status

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'active' => :'active',
        :'id' => :'id',
        :'number' => :'number',
        :'revision' => :'revision',
        :'booking_time' => :'bookingTime',
        :'booking_user' => :'bookingUser',
        :'booking_api_user' => :'bookingApiUser',
        :'cashier' => :'cashier',
        :'create_time' => :'createTime',
        :'create_user' => :'createUser',
        :'customer' => :'customer',
        :'description' => :'description',
        :'items_count' => :'itemsCount',
        :'organizational_unit' => :'organizationalUnit',
        :'party_information' => :'partyInformation',
        :'point_of_sale' => :'pointOfSale',
        :'source_organizational_unit' => :'sourceOrganizationalUnit',
        :'supplier' => :'supplier',
        :'comment' => :'comment',
        :'deposit' => :'deposit',
        :'pickup_date' => :'pickupDate',
        :'store_order' => :'storeOrder',
        :'special_offer_code' => :'specialOfferCode',
        :'shipping_condition' => :'shippingCondition',
        :'shipping_supplier_information' => :'shippingSupplierInformation',
        :'expected_from_date' => :'expectedFromDate',
        :'expected_to_date' => :'expectedToDate',
        :'items' => :'items',
        :'status' => :'status'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'active' => :'Boolean',
        :'id' => :'String',
        :'number' => :'String',
        :'revision' => :'Integer',
        :'booking_time' => :'DateTime',
        :'booking_user' => :'ModelReference',
        :'booking_api_user' => :'ModelReference',
        :'cashier' => :'ModelReference',
        :'create_time' => :'DateTime',
        :'create_user' => :'ModelReference',
        :'customer' => :'ModelReference',
        :'description' => :'String',
        :'items_count' => :'Integer',
        :'organizational_unit' => :'ModelReference',
        :'party_information' => :'ProductTransferInvolvedPartyInformation',
        :'point_of_sale' => :'ModelReference',
        :'source_organizational_unit' => :'ModelReference',
        :'supplier' => :'ModelReference',
        :'comment' => :'String',
        :'deposit' => :'Float',
        :'pickup_date' => :'DateTime',
        :'store_order' => :'ModelReference',
        :'special_offer_code' => :'String',
        :'shipping_condition' => :'String',
        :'shipping_supplier_information' => :'String',
        :'expected_from_date' => :'DateTime',
        :'expected_to_date' => :'DateTime',
        :'items' => :'Array<StockOrderItem>',
        :'status' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `KoronaCloudClient::StockOrder` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `KoronaCloudClient::StockOrder`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'number')
        self.number = attributes[:'number']
      end

      if attributes.key?(:'revision')
        self.revision = attributes[:'revision']
      end

      if attributes.key?(:'booking_time')
        self.booking_time = attributes[:'booking_time']
      end

      if attributes.key?(:'booking_user')
        self.booking_user = attributes[:'booking_user']
      end

      if attributes.key?(:'booking_api_user')
        self.booking_api_user = attributes[:'booking_api_user']
      end

      if attributes.key?(:'cashier')
        self.cashier = attributes[:'cashier']
      end

      if attributes.key?(:'create_time')
        self.create_time = attributes[:'create_time']
      end

      if attributes.key?(:'create_user')
        self.create_user = attributes[:'create_user']
      end

      if attributes.key?(:'customer')
        self.customer = attributes[:'customer']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'items_count')
        self.items_count = attributes[:'items_count']
      end

      if attributes.key?(:'organizational_unit')
        self.organizational_unit = attributes[:'organizational_unit']
      end

      if attributes.key?(:'party_information')
        self.party_information = attributes[:'party_information']
      end

      if attributes.key?(:'point_of_sale')
        self.point_of_sale = attributes[:'point_of_sale']
      end

      if attributes.key?(:'source_organizational_unit')
        self.source_organizational_unit = attributes[:'source_organizational_unit']
      end

      if attributes.key?(:'supplier')
        self.supplier = attributes[:'supplier']
      end

      if attributes.key?(:'comment')
        self.comment = attributes[:'comment']
      end

      if attributes.key?(:'deposit')
        self.deposit = attributes[:'deposit']
      end

      if attributes.key?(:'pickup_date')
        self.pickup_date = attributes[:'pickup_date']
      end

      if attributes.key?(:'store_order')
        self.store_order = attributes[:'store_order']
      end

      if attributes.key?(:'special_offer_code')
        self.special_offer_code = attributes[:'special_offer_code']
      end

      if attributes.key?(:'shipping_condition')
        self.shipping_condition = attributes[:'shipping_condition']
      end

      if attributes.key?(:'shipping_supplier_information')
        self.shipping_supplier_information = attributes[:'shipping_supplier_information']
      end

      if attributes.key?(:'expected_from_date')
        self.expected_from_date = attributes[:'expected_from_date']
      end

      if attributes.key?(:'expected_to_date')
        self.expected_to_date = attributes[:'expected_to_date']
      end

      if attributes.key?(:'items')
        if (value = attributes[:'items']).is_a?(Array)
          self.items = value
        end
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      status_validator = EnumAttributeValidator.new('String', ["BOOKED", "IN_PROGRESS"])
      return false unless status_validator.valid?(@status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ["BOOKED", "IN_PROGRESS"])
      unless validator.valid?(status)
        fail ArgumentError, "invalid value for \"status\", must be one of #{validator.allowable_values}."
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          active == o.active &&
          id == o.id &&
          number == o.number &&
          revision == o.revision &&
          booking_time == o.booking_time &&
          booking_user == o.booking_user &&
          booking_api_user == o.booking_api_user &&
          cashier == o.cashier &&
          create_time == o.create_time &&
          create_user == o.create_user &&
          customer == o.customer &&
          description == o.description &&
          items_count == o.items_count &&
          organizational_unit == o.organizational_unit &&
          party_information == o.party_information &&
          point_of_sale == o.point_of_sale &&
          source_organizational_unit == o.source_organizational_unit &&
          supplier == o.supplier &&
          comment == o.comment &&
          deposit == o.deposit &&
          pickup_date == o.pickup_date &&
          store_order == o.store_order &&
          special_offer_code == o.special_offer_code &&
          shipping_condition == o.shipping_condition &&
          shipping_supplier_information == o.shipping_supplier_information &&
          expected_from_date == o.expected_from_date &&
          expected_to_date == o.expected_to_date &&
          items == o.items &&
          status == o.status
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [active, id, number, revision, booking_time, booking_user, booking_api_user, cashier, create_time, create_user, customer, description, items_count, organizational_unit, party_information, point_of_sale, source_organizational_unit, supplier, comment, deposit, pickup_date, store_order, special_offer_code, shipping_condition, shipping_supplier_information, expected_from_date, expected_to_date, items, status].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        KoronaCloudClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
